import { ActivityIndicator as A } from "@vue-interface/activity-indicator";
import { Autogrow as T } from "@vue-interface/autogrow";
import { FormControl as E } from "@vue-interface/form-control";
import { defineComponent as z, resolveComponent as m, resolveDirective as u, openBlock as s, createElementBlock as a, normalizeClass as v, renderSlot as r, toDisplayString as l, createCommentVNode as n, createElementVNode as i, withDirectives as N, mergeProps as V, vModelText as B, createVNode as b, Transition as S, withCtx as f, createBlock as k, normalizeProps as y, guardReactiveProps as $, createTextVNode as D } from "vue";
const I = z({
  name: "TextareaField",
  directives: {
    Autogrow: T
  },
  components: {
    ActivityIndicator: A
  },
  extends: E,
  props: {
    /**
     * The autogrow attribute
     *
     * @property Boolean
     */
    autogrow: {
      type: [Number, String, Boolean],
      default: !1
    }
  }
}), P = (e, t) => {
  const d = e.__vccOpts || e;
  for (const [c, p] of t)
    d[c] = p;
  return d;
}, G = ["for"], M = { class: "form-group-inner" }, O = {
  invalid: "",
  class: "invalid-feedback"
}, R = /* @__PURE__ */ i("br", null, null, -1), U = {
  valid: "",
  class: "valid-feedback"
};
function j(e, t, d, c, p, q) {
  const C = m("ActivityIndicator"), g = m("FormControlErrors"), F = m("FormControlFeedback"), h = u("autogrow"), w = u("bind-events");
  return s(), a("div", {
    class: v(e.formGroupClasses)
  }, [
    r(e.$slots, "label", {}, () => [
      e.label ? (s(), a("label", {
        key: 0,
        ref: "label",
        for: e.id,
        class: v(e.labelClass)
      }, l(e.label), 11, G)) : n("", !0)
    ]),
    i("div", M, [
      r(e.$slots, "control", {
        bindEvents: e.bindEvents,
        controlAttributes: e.controlAttributes,
        focus: e.focus
      }, () => [
        e.$slots.icon ? (s(), a("div", {
          key: 0,
          class: "form-group-inner-icon",
          onClick: t[0] || (t[0] = (...o) => e.focus && e.focus(...o))
        }, [
          r(e.$slots, "icon")
        ])) : n("", !0),
        N(i("textarea", V({
          ref: "field",
          "onUpdate:modelValue": t[1] || (t[1] = (o) => e.model = o)
        }, e.controlAttributes), null, 16), [
          [B, e.model],
          [h, e.autogrow],
          [w]
        ])
      ]),
      r(e.$slots, "activity", {}, () => [
        b(S, { name: "textarea-field-fade" }, {
          default: f(() => [
            e.activity && e.indicator ? (s(), k(C, {
              key: "activity",
              ref: "activity",
              type: e.indicator,
              size: e.indicatorSize
            }, null, 8, ["type", "size"])) : n("", !0)
          ]),
          _: 1
        })
      ])
    ]),
    r(e.$slots, "errors", y($({ error: e.error, errors: e.errors, id: e.$attrs.id, name: e.$attrs.name })), () => [
      e.error || e.errors ? (s(), k(g, {
        key: 0,
        id: e.$attrs.id,
        name: e.$attrs.name,
        error: e.error,
        errors: e.errors
      }, {
        default: f(({ error: o }) => [
          i("div", O, [
            D(l(o), 1),
            R
          ])
        ]),
        _: 1
      }, 8, ["id", "name", "error", "errors"])) : n("", !0)
    ]),
    r(e.$slots, "feedback", y($({ feedback: e.feedback })), () => [
      b(F, { feedback: e.feedback }, {
        default: f(({ feedback: o }) => [
          i("div", U, l(o), 1)
        ]),
        _: 1
      }, 8, ["feedback"])
    ]),
    r(e.$slots, "help", {}, () => [
      e.helpText ? (s(), a("small", {
        key: 0,
        ref: "help"
      }, l(e.helpText), 513)) : n("", !0)
    ])
  ], 2);
}
const Q = /* @__PURE__ */ P(I, [["render", j]]);
export {
  Q as TextareaField
};
//# sourceMappingURL=textarea-field.js.map
